std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc > Class Template Reference

`#include <unordered_set>`

Inherits unordered_multiset< _Value, std::hash< _Value >, std::equal_to< _Value >, std::allocator< _Value > >, and std::__profile::_Unordered_profile< _UnorderedCont, _Unique_keys >.

## Public Types

typedef _Base::allocator_type | allocator_type
typedef _Base::const_iterator | const_iterator
typedef _Base::const_reference | const_reference
typedef _Base::difference_type | difference_type
typedef _Base::hasher | hasher
typedef _Base::iterator | iterator
typedef _Base::key_equal | key_equal
typedef _Base::key_type | key_type
typedef _Base::reference | reference
typedef _Base::size_type | size_type
typedef _Base::value_type | value_type

## Public Member Functions

template<typename _InputIterator >
| unordered_multiset (_InputIterator __f, _InputIterator __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
template<typename _InputIterator >
| unordered_multiset (_InputIterator __first, _InputIterator __last, size_type __n, const allocator_type &__a)
template<typename _InputIterator >
| unordered_multiset (_InputIterator __first, _InputIterator __last, size_type __n, const hasher &__hf, const allocator_type &__a)
| unordered_multiset (const _Base &__x)
| unordered_multiset (const allocator_type &__a)
| unordered_multiset (const unordered_multiset &)=default
| unordered_multiset (const unordered_multiset &__umset, const allocator_type &__a)
| unordered_multiset (initializer_list< value_type > __l, size_type __n, const allocator_type &__a)
| unordered_multiset (initializer_list< value_type > __l, size_type __n, const hasher &__hf, const allocator_type &__a)
| unordered_multiset (initializer_list< value_type > __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
| unordered_multiset (size_type __n, const allocator_type &__a)
| unordered_multiset (size_type __n, const hasher &__hf, const allocator_type &__a)
| unordered_multiset (size_type __n, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
| unordered_multiset (unordered_multiset &&)=default
| unordered_multiset (unordered_multiset &&__umset, const allocator_type &__a)
void | clear () noexcept
template<typename... _Args>
iterator | emplace (_Args &&... __args)
template<typename... _Args>
iterator | emplace_hint (const_iterator __it, _Args &&... __args)
template<typename _InputIter >
void | insert (_InputIter __first, _InputIter __last)
iterator | insert (const value_type &__obj)
iterator | insert (const_iterator __iter, const value_type &__v)
iterator | insert (const_iterator __iter, value_type &&__v)
void | insert (std::initializer_list< value_type > __l)
iterator | insert (value_type &&__obj)
unordered_multiset & | operator= (const unordered_multiset &)=default
unordered_multiset & | operator= (initializer_list< value_type > __l)
unordered_multiset & | operator= (unordered_multiset &&)=default
void | rehash (size_type __n)
void | swap (unordered_multiset &__x) noexcept(noexcept(__x._M_base().swap(__x)))

## Protected Member Functions

void | _M_profile_construct () noexcept
void | _M_profile_destruct () noexcept
void | _M_profile_resize (std::size_t __old_size)
void | _M_swap (_Unordered_profile &__other) noexcept

## Protected Attributes

__gnu_profile::__hashfunc_info * | _M_hashfunc_info
__gnu_profile::__container_size_info * | _M_size_info

## Detailed Description

template<typename _Value, typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>
class std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >

Unordered_multiset wrapper with performance instrumentation.

Definition at line 307 of file profile/unordered_set.

## Member Typedef Documentation

## allocator_type

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

typedef _Base::allocator_type std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::allocator_type

Definition at line 325 of file profile/unordered_set.

## const_iterator

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

typedef _Base::const_iterator std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::const_iterator

Definition at line 333 of file profile/unordered_set.

## const_reference

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

typedef _Base::const_reference std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::const_reference

Definition at line 330 of file profile/unordered_set.

## difference_type

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

typedef _Base::difference_type std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::difference_type

Definition at line 328 of file profile/unordered_set.

## hasher

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

typedef _Base::hasher std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::hasher

Definition at line 323 of file profile/unordered_set.

## iterator

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

typedef _Base::iterator std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::iterator

Definition at line 332 of file profile/unordered_set.

## key_equal

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

typedef _Base::key_equal std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::key_equal

Definition at line 324 of file profile/unordered_set.

## key_type

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

typedef _Base::key_type std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::key_type

Definition at line 326 of file profile/unordered_set.

## reference

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

typedef _Base::reference std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::reference

Definition at line 329 of file profile/unordered_set.

## size_type

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

typedef _Base::size_type std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::size_type

Definition at line 322 of file profile/unordered_set.

## value_type

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

typedef _Base::value_type std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::value_type

Definition at line 327 of file profile/unordered_set.

## Constructor & Destructor Documentation

## unordered_multiset() [1/13]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | size_type | __n,
|  | const hasher & | __hf = `hasher()`,
|  | const key_equal & | __eql = `key_equal()`,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline explicit

Definition at line 338 of file profile/unordered_set.

## unordered_multiset() [2/13]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>
template<typename _InputIterator >

std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | _InputIterator | __f,
|  | _InputIterator | __l,
|  | size_type | __n = `0`,
|  | const hasher & | __hf = `hasher()`,
|  | const key_equal & | __eql = `key_equal()`,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline

Definition at line 346 of file profile/unordered_set.

## unordered_multiset() [3/13]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | const _Base & | __x | ) |

inline

Definition at line 356 of file profile/unordered_set.

## unordered_multiset() [4/13]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | const allocator_type & | __a | ) |

inline explicit

Definition at line 363 of file profile/unordered_set.

## unordered_multiset() [5/13]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | const unordered_multiset< _Value, _Hash, _Pred, _Alloc > & | __umset,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 367 of file profile/unordered_set.

## unordered_multiset() [6/13]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | unordered_multiset< _Value, _Hash, _Pred, _Alloc > && | __umset,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 372 of file profile/unordered_set.

## unordered_multiset() [7/13]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | initializer_list< value_type > | __l,
|  | size_type | __n = `0`,
|  | const hasher & | __hf = `hasher()`,
|  | const key_equal & | __eql = `key_equal()`,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline

Definition at line 377 of file profile/unordered_set.

## unordered_multiset() [8/13]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | size_type | __n,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 385 of file profile/unordered_set.

## unordered_multiset() [9/13]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | size_type | __n,
|  | const hasher & | __hf,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 389 of file profile/unordered_set.

## unordered_multiset() [10/13]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>
template<typename _InputIterator >

std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | size_type | __n,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 395 of file profile/unordered_set.

## unordered_multiset() [11/13]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>
template<typename _InputIterator >

std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | size_type | __n,
|  | const hasher & | __hf,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 402 of file profile/unordered_set.

## unordered_multiset() [12/13]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | initializer_list< value_type > | __l,
|  | size_type | __n,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 408 of file profile/unordered_set.

## unordered_multiset() [13/13]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | initializer_list< value_type > | __l,
|  | size_type | __n,
|  | const hasher & | __hf,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 414 of file profile/unordered_set.

## Member Function Documentation

## _M_profile_construct()

template<typename _UnorderedCont , bool _Unique_keys>

void std::__profile::_Unordered_profile< _UnorderedCont, _Unique_keys >::_M_profile_construct | ( |  | ) |

inline protected noexcept inherited

Definition at line 190 of file unordered_base.h.

## _M_profile_destruct()

template<typename _UnorderedCont , bool _Unique_keys>

void std::__profile::_Unordered_profile< _UnorderedCont, _Unique_keys >::_M_profile_destruct | ( |  | ) |

inline protected noexcept inherited

Definition at line 198 of file unordered_base.h.

## _M_profile_resize()

template<typename _UnorderedCont , bool _Unique_keys>

void std::__profile::_Unordered_profile< _UnorderedCont, _Unique_keys >::_M_profile_resize | ( | std::size_t | __old_size | ) |

inline protected inherited

Definition at line 220 of file unordered_base.h.

## _M_swap()

template<typename _UnorderedCont , bool _Unique_keys>

void std::__profile::_Unordered_profile< _UnorderedCont, _Unique_keys >::_M_swap | ( | _Unordered_profile< _UnorderedCont, _Unique_keys > & | __other | ) |

inline protected noexcept inherited

Definition at line 213 of file unordered_base.h.

## clear()

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

void std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::clear | ( |  | ) |

inline noexcept

Definition at line 444 of file profile/unordered_set.

## emplace()

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>
template<typename... _Args>

iterator std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::emplace | ( | _Args &&... | __args | ) |

inline

Definition at line 453 of file profile/unordered_set.

## emplace_hint()

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>
template<typename... _Args>

iterator std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::emplace_hint | ( | const_iterator | __it,
|  | _Args &&... | __args
| ) |  |

inline

Definition at line 463 of file profile/unordered_set.

## insert() [1/6]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>
template<typename _InputIter >

void std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | _InputIter | __first,
|  | _InputIter | __last
| ) |  |

inline

Definition at line 518 of file profile/unordered_set.

## insert() [2/6]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

iterator std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | const value_type & | __obj | ) |

inline

Definition at line 481 of file profile/unordered_set.

## insert() [3/6]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

iterator std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | const_iterator | __iter,
|  | const value_type & | __v
| ) |  |

inline

Definition at line 490 of file profile/unordered_set.

## insert() [4/6]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

iterator std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | const_iterator | __iter,
|  | value_type && | __v
| ) |  |

inline

Definition at line 508 of file profile/unordered_set.

## insert() [5/6]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

void std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | std::initializer_list< value_type > | __l | ) |

inline

Definition at line 473 of file profile/unordered_set.

## insert() [6/6]

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

iterator std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | value_type && | __obj | ) |

inline

Definition at line 499 of file profile/unordered_set.

## operator=()

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

unordered_multiset & std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::operator= | ( | initializer_list< value_type > | __l | ) |

inline

Definition at line 427 of file profile/unordered_set.

## rehash()

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

void std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::rehash | ( | size_type | __n | ) |

inline

Definition at line 526 of file profile/unordered_set.

## swap()

template<typename _Value , typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>

void std::__profile::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::swap | ( | unordered_multiset< _Value, _Hash, _Pred, _Alloc > & | __x | ) |

inline noexcept

Definition at line 436 of file profile/unordered_set.

## Member Data Documentation

## _M_hashfunc_info

template<typename _UnorderedCont , bool _Unique_keys>

__gnu_profile::__hashfunc_info* std::__profile::_Unordered_profile< _UnorderedCont, _Unique_keys >::_M_hashfunc_info

protected inherited

Definition at line 228 of file unordered_base.h.

## _M_size_info

template<typename _UnorderedCont , bool _Unique_keys>

__gnu_profile::__container_size_info* std::__profile::_Unordered_profile< _UnorderedCont, _Unique_keys >::_M_size_info

protected inherited

Definition at line 227 of file unordered_base.h.

The documentation for this class was generated from the following file:

- profile/unordered_set